# Vim.js
Simple vim for web textarea and input field, to improve writing experience on web.

![demo gif](http://7o503b.com1.z0.glb.clouddn.com/demo.gif)

**Note:**
* This project is in development, there will be some improvements and new features.
* 一般模式/视图模式中的指令需在英文输入法下输入

# usage

```html
...
<script src="/path/to/vim.js"></script>
<script type="text/javascript">
    vim.open({
        debug   : true,
        showMsg : function(msg){
            alert('vim.js say:' + msg);
        }
    });
</script>
...
```
# Building
```
//watch
npm run dev

//build
npm run build

//build min js file
npm run build_min
```

# supported browser

* Chrome  v39
* Firefox  v34, v40
* Safari

**Note:** Whether to support other browsers still unknown

# supported features

## 1. general mode
|  指令  |        说明             |
| ----- | ----------------------- |
| Esc   | 由编辑模式切换到一般模式    |
| u     | 复原前一个操作，支持多个文本域/输入框独立复原|
|          移动光标:               |
| h或左箭头键(←) | 光标向左移动一个字符   |
| j或下箭头键(↓) | 光标向下移动一个字符   |
| k或上箭头键(↑) | 光标向上移动一个字符   |
| l或右箭头键(→) | 光标向右移动一个字符   |
| 如果想进行多次移动，例如向下移动10行，可以使用"10j"，或"10↓"的组合键|
| 0或功能键[HOME]| 光标移动到当前行的第一个字符处 |
| $或功能键[End] | 光标移动到当前行的最后一个字符处 |
| G             | 光标移动到最后一行    |
| gg            | 光标移动到第一行      |
|          删除、复制与粘贴:        |
| x或功能键[Delete] | 向后删除一个字符 |
| nx或n[Delete] | 向后删除个字符 |
| yy           | 复制当前行      |
| nyy          | 向下复制n行     |
| dd           | 删除当前行      |
| ndd          | 向下删除n行      |
| p,P          | p向后粘贴，P向前粘贴|

## 2. switch to edit mode
|  指令  |        说明             |
| ----- | ----------------------- |
| 进入插入或替换的编辑模式            |
| i     | 从目前光标所在出插入       |
| a     | 从目前光标所在的下一个字符处出插入|
| o,O   | o为在目前光标所在处的下一行处插入新的一行，O为在上一行插入新一行|
| r     | 替换光标所在的那一个字符    |

## 3. switch to visual mode
|  指令  |        说明             |
| ----- | ----------------------- |
| v,V   | 切换到视图模式，即多字符选择模式|
| y     | 复制选中的所有字符         |
| x,d   | 删除选中的所有字符         |